package com.bergerkiller.bukkit.nolagg;

import java.util.HashSet;
import java.util.List;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Item;
import org.bukkit.inventory.ItemStack;
import org.bukkit.util.Vector;

import com.bergerkiller.bukkit.common.utils.ItemUtil;
import com.bergerkiller.bukkit.nolagg.meta.ChunkMetaData;

public class ItemHandler {
	public static int maxItemsPerChunk;
	public static boolean formStacks;
	public static boolean ignoreSpawn = false;
	private static HashSet<Material> ignoredTypes = new HashSet<Material>();
				
	public static boolean isIgnoredItem(Entity itementity) {
		if (ItemUtil.isIgnored(itementity)) return true;
		Item item = (Item) itementity;
		return ignoredTypes.contains(item.getItemStack().getType());
	}
	
	public static void clearIgnoredTypes() {
		ignoredTypes.clear();
	}
	public static void addIgnoredType(Material type) {
		ignoredTypes.add(type);
	}
	
	public static void setItem(Item item, ItemStack data) {
		boolean prev = ignoreSpawn;
		ignoreSpawn = true;
		item.remove();
		item.getWorld().dropItem(item.getLocation(), data);
		ignoreSpawn = prev;
	}
	
	public static Item respawnItem(Item item) {
		return respawnItem(item, item.getVelocity(), true);
	}
	public static Item respawnItem(Item item, Vector velocity) {
		return respawnItem(item, velocity, false);
	}
	public static Item respawnItem(Item item, Vector velocity, boolean naturally) {
		if (item.isDead()) return item;
		ignoreSpawn = true;
		item.remove();
		ChunkMetaData dat = ChunkMetaData.get(item.getLocation().getChunk());
		List<Item> items = dat == null ? null : dat.getSpawnedItems();
		if (items != null) items.remove(item);
		//Get required data
		World w = item.getWorld();
		Location l = item.getLocation();
		ItemStack data = item.getItemStack();
		if (data == null) data = new ItemStack(5, 1);
		int pickupdelay = -1;
		try {
			pickupdelay = item.getPickupDelay();
		} catch (Throwable t) {}
		//Respawn and set properties
		if (naturally) {
			item = w.dropItemNaturally(l, data);
		} else {
			item = w.dropItem(l, data);
		}
		item.setVelocity(velocity);
		if (pickupdelay != -1) {
			item.setPickupDelay(pickupdelay);
		}
		if (items != null) items.add(item);
		ignoreSpawn = false;
		return item;
	}
	
}
